Index: django/views/generic/date_based.py
===================================================================
--- django/views/generic/date_based.py	(wersja 15499)
+++ django/views/generic/date_based.py	(kopia robocza)
@@ -34,7 +34,7 @@
         queryset = queryset.filter(**{'%s__lte' % date_field: datetime.datetime.now()})
     date_list = queryset.dates(date_field, 'year')[::-1]
     if not date_list and not allow_empty:
-        raise Http404("No %s available" % model._meta.verbose_name)
+        raise Http404("No %s available" % model._meta.object_name)
 
     if date_list and num_latest:
         latest = queryset.order_by('-'+date_field)[:num_latest]
@@ -354,7 +354,7 @@
     try:
         obj = queryset.get(**lookup_kwargs)
     except ObjectDoesNotExist:
-        raise Http404("No %s found for" % model._meta.verbose_name)
+        raise Http404("No %s found for" % model._meta.object_name)
     if not template_name:
         template_name = "%s/%s_detail.html" % (model._meta.app_label, model._meta.object_name.lower())
     if template_name_field:
Index: django/views/generic/list_detail.py
===================================================================
--- django/views/generic/list_detail.py	(wersja 15499)
+++ django/views/generic/list_detail.py	(kopia robocza)
@@ -131,7 +131,7 @@
     try:
         obj = queryset.get()
     except ObjectDoesNotExist:
-        raise Http404("No %s found matching the query" % (model._meta.verbose_name))
+        raise Http404("No %s found matching the query" % (model._meta.object_name))
     if not template_name:
         template_name = "%s/%s_detail.html" % (model._meta.app_label, model._meta.object_name.lower())
     if template_name_field:
Index: django/views/generic/dates.py
===================================================================
--- django/views/generic/dates.py	(wersja 15499)
+++ django/views/generic/dates.py	(kopia robocza)
@@ -194,7 +194,7 @@
             qs = qs.filter(**{'%s__lte' % date_field: datetime.datetime.now()})
 
         if not allow_empty and not qs:
-            raise Http404(u"No %s available" % unicode(qs.model._meta.verbose_name_plural))
+            raise Http404(u"No %s list available" % unicode(qs.model._meta.object_name))
 
         return qs
 
@@ -208,7 +208,7 @@
 
         date_list = queryset.dates(date_field, date_type)[::-1]
         if date_list is not None and not date_list and not allow_empty:
-            raise Http404(u"No %s available" % unicode(qs.model._meta.verbose_name_plural))
+            raise Http404(u"No %s list available" % unicode(qs.model._meta.object_name))
 
         return date_list
 
@@ -458,8 +458,8 @@
         qs = self.get_queryset()
 
         if not self.get_allow_future() and date > datetime.date.today():
-            raise Http404("Future %s not available because %s.allow_future is False." % (
-                qs.model._meta.verbose_name_plural, self.__class__.__name__)
+            raise Http404("Future %s list is not available because %s.allow_future is False." % (
+                qs.model._meta.object_name, self.__class__.__name__)
             )
 
         # Filter down a queryset from self.queryset using the date from the
Index: django/views/generic/detail.py
===================================================================
--- django/views/generic/detail.py	(wersja 15499)
+++ django/views/generic/detail.py	(kopia robocza)
@@ -48,7 +48,7 @@
             obj = queryset.get()
         except ObjectDoesNotExist:
             raise Http404(u"No %s found matching the query" %
-                          (queryset.model._meta.verbose_name))
+                          (queryset.model._meta.object_name))
         return obj
 
     def get_queryset(self):
Index: django/views/generic/create_update.py
===================================================================
--- django/views/generic/create_update.py	(wersja 15499)
+++ django/views/generic/create_update.py	(kopia robocza)
@@ -95,7 +95,7 @@
         return model.objects.get(**lookup_kwargs)
     except ObjectDoesNotExist:
         raise Http404("No %s found for %s"
-                      % (model._meta.verbose_name, lookup_kwargs))
+                      % (model._meta.object_name, lookup_kwargs))
 
 def create_object(request, model=None, template_name=None,
         template_loader=loader, extra_context=None, post_save_redirect=None,